package com.zhentao.groups.im;



import com.zhentao.groups.im.handler.WebSocketHandler;
import io.netty.bootstrap.ServerBootstrap;
import io.netty.channel.*;
import io.netty.channel.group.ChannelGroup;
import io.netty.channel.nio.NioEventLoopGroup;
import io.netty.channel.socket.SocketChannel;
import io.netty.channel.socket.nio.NioServerSocketChannel;
import io.netty.handler.codec.http.HttpObjectAggregator;
import io.netty.handler.codec.http.HttpServerCodec;
import io.netty.handler.codec.http.websocketx.WebSocketServerProtocolHandler;
import io.netty.handler.stream.ChunkedWriteHandler;

import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;

public class ImServer {

    public static final Map<Long,Channel> USERS=new ConcurrentHashMap<>();

//    public static final ChannelGroup GROUP=new DefaultChannelGroup(GlobalEventExecutor.INSTANCE);

    public static final Map<String,ChannelGroup> GROUP=new ConcurrentHashMap<>();
    public static void start(){
        EventLoopGroup boss=new NioEventLoopGroup();

        EventLoopGroup worker=new NioEventLoopGroup();

//        监听端口
        ServerBootstrap bootstrap=new ServerBootstrap();

        bootstrap.group(boss,worker)
                .channel(NioServerSocketChannel.class)
                .childHandler(new ChannelInitializer<SocketChannel>() {
                    @Override
                    protected void initChannel(SocketChannel socketChannel) throws Exception {
                        ChannelPipeline pipeline = socketChannel.pipeline();
                        //  添加http编码解码器
                        pipeline.addLast(new HttpServerCodec())
                                // 支持大数据
                                .addLast(new ChunkedWriteHandler())
                                //  对http消息做聚合操作
                                .addLast(new HttpObjectAggregator(1024*64))
                                .addLast(new WebSocketServerProtocolHandler("/"))
                                // 自定义
                                .addLast(new WebSocketHandler());
                    }
                });

        ChannelFuture future=bootstrap.bind(8888);
    }

}
